<?php
/*
Plugin Name: Stats IP Excluder
Version: 2.0
Description: Permet l'exclusion d'une IP ou d'une plage d'IP des statistiques - Excludes one IP or a range of IP from the stats. Special thx to flipflip, rvelices and EX-FTB for their help !
Plugin URI: http://phpwebgallery.net/ext/extension_view.php?eid=106
Author: P@t
Author URI: http://www.infernoweb.net
*/

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

/* ******************* */
/* Class of the plugin */
/* ******************* */
class IpExclude
{
  var $my_config; /* Configuration file items */
  
  /* Loading of the configuration file - If not exist -> Configuration file creation */
  function load_config()
  {
    $x = @file_get_contents( dirname(__FILE__).'/data.dat' );
    if ($x!==false)
    {
      $c = unserialize($x);
      // do some more tests here
      $this->my_config = $c;
    }
    if ( !isset($this->my_config)
        or empty($this->my_config['ip_excluded']) )
    {
      $this->my_config['ip_excluded'] = array( '' ); /* list of IP to exclude */
      $this->my_config['ip_activated'] = false; /* Possibility to disactivate the exclusion */
      $this->save_config();
    }
  }

  /* Saving of the configuration file with data */
  function save_config()
  {
    $file = fopen( dirname(__FILE__).'/data.dat', 'w' );
    fwrite($file, serialize($this->my_config) );
    fclose( $file );
  }

/* Set the administration panel of the plugin */
  function plugin_admin_menu($menu)
  {
    array_push($menu,
        array(
          'NAME' => 'IP Excluder',
          'URL' => get_admin_plugin_menu_link(dirname(__FILE__).'/admin/ip_exclude_admin.php')
        )
      );
    return $menu;
  }

/* Exclusion function */
  function IpExclusion($pwg_will_log)
  {
	if (!$pwg_will_log) return $pwg_will_log;
	$do_log = true;
	foreach ( $this->my_config['ip_excluded'] as $Exclusion )
		{
			if ($this->my_config['ip_activated'])
	    	{
				$do_log = false;
			}
		    else
		    {
				$do_log = true;
		    }
		}
	return $do_log;
  }
}

$obj = new IpExclude(); /* class loading */
$obj->load_config(); /* Configuration file loading */

add_event_handler( 'pwg_log_allowed', array(&$obj, 'IpExclusion') );
add_event_handler('get_admin_plugin_menu_links', array(&$obj, 'plugin_admin_menu') );
set_plugin_data($plugin['id'], $obj);
?>